//---------------------------------------------------------------------------
//
// TBufferPaint -
// Component header file
//
// (C) 2000 Thomas Wolf / Remotion
//
// Contact me at:
// remotion@chello.at
//
//---------------------------------------------------------------------------

#ifndef BufferPaintH
#define BufferPaintH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#pragma warn -inl
//---------------------------------------------------------------------------

typedef void __fastcall (__closure *TBufferPaintEvent)
    (System::TObject *Sender, bool *Stop);

class PACKAGE TBufferPaint : public TCustomControl
{
private:

protected:
    TColor              FColor;
    bool                FAutoClear;

    TBufferPaintEvent   FOnPaint;
    TBufferPaintEvent   FOnClear;
    TMouseMoveEvent     FOnMouseEnter;
    TMouseMoveEvent     FOnMouseLeave;

    void __fastcall SetColor             (TColor        Value);
    void __fastcall SetAutoClear         (bool          Value);

    Controls::TWndMethod WindowProcOld;
    void __fastcall WindowProcNew        (TMessage     &Msg);
    MESSAGE void __fastcall WMSize       (TWMSize      &Msg);
    MESSAGE void __fastcall CMMouseEnter (TMessage     &Msg);
    MESSAGE void __fastcall CMMouseLeave (TMessage     &Msg);
    BEGIN_MESSAGE_MAP
        VCL_MESSAGE_HANDLER(WM_SIZE, TWMSize, WMSize);
        VCL_MESSAGE_HANDLER(CM_MOUSEENTER,TMessage,CMMouseEnter)
        VCL_MESSAGE_HANDLER(CM_MOUSELEAVE,TMessage,CMMouseLeave)
    END_MESSAGE_MAP(TCustomControl);

public:
    __fastcall  TBufferPaint    (TComponent* Owner);
    __fastcall ~TBufferPaint    ();
    void __fastcall Paint       ();

    Graphics::TBitmap *Buffer;

__published:
    __property TColor Color =
        { read=FColor, write=SetColor };

    __property bool AutoClear =
        { read=FAutoClear, write=SetAutoClear, default=true };

    __property TBufferPaintEvent OnClear =
        { read=FOnClear, write=FOnClear };

    __property TBufferPaintEvent OnPaint =
        { read=FOnPaint, write=FOnPaint };

    __property TMouseMoveEvent OnMouseEnter =
        { read=FOnMouseEnter, write=FOnMouseEnter };

    __property TMouseMoveEvent OnMouseLeave =
        { read=FOnMouseLeave, write=FOnMouseLeave };

    __property OnMouseMove;
    __property OnMouseDown;
    __property OnMouseUp;
    __property OnKeyPress;
    __property OnKeyDown;
    __property OnKeyUp;

    __property Align;
    __property Anchors;
    __property Action;
    __property Cursor;
    __property Enabled;
    __property Hint;
    __property ShowHint;
};
//---------------------------------------------------------------------------
#endif
 